"use strict";
const arforms_pro_controls = class{

    constructor(){
        this.arforms_init_pro_fields();
    }

    arforms_init_pro_fields(){
        if( 'undefined' == typeof this.slider_fields ){
            this.slider_fields = [];
        }
        this.arforms_initialize_slider_control();
        this.arforms_intiialize_password_strength_meter();
        this.arforms_initialize_smiley_field();
        this.arforms_initialize_wysiwyg_field();
    }

    arforms_is_form_visible( element ){
        if( null == element || 'undefined' == typeof element || '' == element ){
            return false;
        }

        return (0 < jQuery(element).parents( '.arfmodal:not(.arf_active)' ).length);

    }

    arforms_initialize_wysiwyg_field(){
        let allRichTextField = document.querySelectorAll('.arf_rich_text_editor');
        if( null != allRichTextField && 0 < allRichTextField.length ){
            for ( let field of allRichTextField ){
                let fieldOpts = field.getAttribute( 'data-field-options' );

                if( true == this.arforms_is_form_visible( field ) ){
                    continue;
                }
				
				try{
					jQuery(field).trumbowyg('destroy');
				} catch( e ){
					console.log( " RICH TEXT EDITOR COULD NOT BE DESTROYED ");
					console.log( e );
					jQuery(field).parents('.controls').find('div[class^="trumbowyg"]:not(.trumbowyg-box)').remove();
					jQuery(field).parents('.controls').find('textarea.arf_rich_text_editor').unwrap('.trumbowyg-box');
					jQuery(field).parents('.controls').find('textarea.arf_rich_text_editor').removeClass('trumbowyg-textarea');
				}

                let field_options = JSON.parse( fieldOpts );

                let arf_wysiwyg_settings = {
                    svgPath: field.getAttribute( 'data-svg-path' ),
                    btns:[
                        ["undo", "redo"],
                        ["formatting"],
                        ["strong", "em", "del"],
                        ["superscript", "subscript"],
                        ["link"],
                        ["insertImage"],
                        ["justifyLeft", "justifyCenter", "justifyRight", "justifyFull"],
                        ["unorderedList", "orderedList"],
                        ["horizontalRule"],
                        ["removeformat"]
                    ]
                };

                if( 1 != field_options.arf_enable_readonly){
                    arf_wysiwyg_settings.btns.push( ["fullscreen"] );
                } else {
                    arf_wysiwyg_settings.disable = true;
                }
				
				(function(field_s, settings){
					setTimeout( function(){
						jQuery(field).parents('.controls').find('div[class^="trumbowyg"]:not(.trumbowyg-box)').remove();
						jQuery(field).parents('.controls').find('textarea.arf_rich_text_editor').unwrap('.trumbowyg-box');
						jQuery(field).parents('.controls').find('textarea.arf_rich_text_editor').removeClass('trumbowyg-textarea');
						jQuery( field_s ).trumbowyg( settings ).on( 'tbwinit', function(){
							if( this.getAttribute("disabled") != null ){
								this.removeAttribute("disabled");
							}
						}).on("tbwopenfullscreen",function(){
							jQuery(this).parents(".arf_field_type_arf_wysiwyg").addClass("arf_wysiwyg_fullscreen");
						}).on("tbwclosefullscreen",function(){
							jQuery(this).parents(".arf_field_type_arf_wysiwyg").removeClass("arf_wysiwyg_fullscreen");
						});
					},100);
				})( field, arf_wysiwyg_settings );
            }
        }
    }

    arforms_initialize_slider_control(){
        let allSliderFields = document.querySelectorAll( '.arf_slider_field_control' );
        if( null != allSliderFields && 0 < allSliderFields.length ){
            for( let field of allSliderFields ){
                if( true == this.arforms_is_form_visible( field ) ){
                    continue;
                }
                let fieldOpts = field.getAttribute( 'data-field-options' );
                let field_options = JSON.parse( fieldOpts );

                let field_key = field.getAttribute('data-field-key');
                let unique_id = field.getAttribute( 'data-form-data-id');
                let arf_slider_front = document.getElementById(`arf_frontslider_field_${field_key}_slide_${unique_id}`);
                let arf_slider_front_input = document.getElementById(`field_${field_key}_slide_${unique_id}`);

                let slider_options = {
                    connect:'lower',
                    start: parseFloat( field_options.slider_value ),
                    step: parseFloat( field_options.slider_step ),
                    tooltips: [ wNumb( { decimals:1 } ) ],
                    range:{
                        min: parseFloat( field_options.minnum ),
                        max: parseFloat( field_options.maxnum )
                    }
                };

                let stepStr_simple = ( field_options.slider_step ).toString();
                if( stepStr_simple.indexOf(".") == -1){
                    slider_options.tooltips = [ wNumb( {decimals:0} ) ];
                } else {
                    let decimal_points = stepStr_simple.split('.');
                    let point_counts = decimal_points[1].length;
                    slider_options.tooltips = [wNumb({decimals:point_counts})];
                }

                let arf_range_minimum = ( 'undefined' != typeof field_options.arf_range_minnum && '' != field_options.arf_range_minnum ) ? field_options.arf_range_minnum : field_options.minnum;
                let arf_range_maximum = ( 'undefined' != typeof field_options.arf_range_maxnum && '' != field_options.arf_range_maxnum ) ? field_options.arf_range_maxnum : field_options.maxnum;

                if( '1' == field_options.arf_range_selector ){
                    slider_options.start = [ arf_range_minimum, arf_range_maximum ];
                    slider_options.tooltips = [ wNumb({decimals: 1}), wNumb({decimals: 1})];
                    slider_options.connect = true;
                    var stepStr_range = (field_options.slider_step).toString();
                    if( stepStr_range.indexOf(".") == -1){
                        slider_options.tooltips = [wNumb({decimals:0}), wNumb({decimals:0})];
                    } else {
                        let decimal_points = stepStr_range.split('.');
                        let point_counts = decimal_points[1].length;
                        slider_options.tooltips = [wNumb({decimals:point_counts}), wNumb({decimals:point_counts})];
                    }
                }

                try{
                    if( 'undefined' != typeof this.slider_fields && 0 < this.slider_fields.length ){
                        for( let sfield of this.slider_fields ){
                            jQuery( '.noUi-base ').remove();
                            if( 'undefined' != typeof sfield.noUiSlider ){
                                sfield.noUiSlider.destroy();
                            }
                        }
                    }
                } catch ( e ){
                    /** Do nothing */
                }
				setTimeout(function(){
					noUiSlider.create( arf_slider_front, slider_options );

					arforms_pro_controls_obj.slider_fields.push( arf_slider_front );

					arf_slider_front.noUiSlider.on( 'update', function( values, handle){
						if ( '1' == field_options.arf_range_selector ) {
							let val1 = values[0];
                            let val2 = values[1];
                            let finalVal = val1 + "," + val2;
							jQuery(`#field_${field_key}_${unique_id}`).val(finalVal).trigger("change").trigger('keyup');
						} else {
                            var steps = field_options.slider_step;
                            
                            if(/\./.test(steps)){
                                var val = arf_slider_front_input.innerHTML = values[handle];
                            }else{
							    var val = arf_slider_front_input.innerHTML = Math.round(values[handle]);
                            }
                        
							if(val || val == "0"){
								jQuery(`#field_${field_key}_${unique_id}`).val(val).trigger("change").trigger('keyup');
							}
						}
					});
				},100);
            }
        }
    }

    arforms_intiialize_password_strength_meter(){
        let allPasswordFields = document.querySelectorAll('.arf_strenth_mtr');

        if( null != allPasswordFields && 0 < allPasswordFields.length ){
            for( let field of allPasswordFields ){
                let field_data_id = field.getAttribute( 'data-field-id' );

                jQuery(`#field_${field_data_id}`).on('keyup',function(){
                    if( 'function' == typeof arf_password_meter ){
                        arf_password_meter( field_data_id );
                    }
                });
            }
        }
    }

    arforms_initialize_smiley_field(){
        let allSmileyFields = document.querySelectorAll( '.arf_smiley_btn' );

        if( null != allSmileyFields && 0 < allSmileyFields.length ){
            for( let field of allSmileyFields ){
                let title = field.getAttribute( 'data-title' );
                if( 'undefined' != typeof title ){
                    jQuery( field ).arf_popover({
                        html: true,
                        trigger: "hover",
                        placement: "top",
                        content: title,
                        title: "",
                        animation: false
                    });
                }
            }
        }
    }

}

const arforms_pro_controls_obj = new arforms_pro_controls();