(function() {
    function $id(id) {
        return document.getElementById(id);
    }
    function Output(msg) {
        var m = $id("messages");
    }
    function FileSelectHandler2(e) {
        
        var files = e.target.files || e.dataTransfer.files;
        for (var i = 0, f; f = files[i]; i++) {
            var field_key = jQuery(this).attr('data-val');
            UploadFile(f, field_key);
        }
    }
    function FileEmailAttachmentHandler(e){
        var files = e.target.files || e.dataTransfer.files;
        for (var i = 0, f; f = files[i]; i++) {
            var field_key = jQuery(this).attr('data-val');
            UploadEmailAttachmentFile(f, field_key);
        }
    }

    function FilePresetFieldHandler(e) {
        var files = e.target.files || e.dataTransfer.files;
        for (var i = 0, f; f = files[i]; i++) {
            var field_key = jQuery(this).attr('data-val');
            UploadPresetFile(f, field_key);
        }
    }

    function UploadPresetFile(file, field_key) {
        var arf_preset_data = file.name;
        var file_ext = arf_preset_data.lastIndexOf('.');
        var file_ext = arf_preset_data.substring(file_ext + 1);
        if (file_ext.toLowerCase() != 'csv') {
            jQuery('#error_message').find('.message_descripiton > div').first().html(__ARF_UPLOAD_CSV_MSG);
            error_msg();
            jQuery('#arf_preset_data_'+field_key).val('');
            return false;
        }
        jQuery('.arf_preset_field_content_wrapper_' + field_key).find('button.btn_2').css('opacity', '0.5');
        var xhr = new XMLHttpRequest();
        var seconds = new Date().getTime();
        var index = file.name.lastIndexOf('.'); 
        var extension = file.name.substring(index + 1); 
        var filename = /.*(?=\.)/.exec(file.name);
        var fname1 = seconds + "_" + filename;
        fname = fname1.replace(/[^\w\s]/gi, '').replace(/ /g, "") + '.' + extension;
        var arf_ajax_url = jQuery('.arf_ajax_url').val();
        xhr.open("POST", arf_ajax_url, true);

        xhr.setRequestHeader("X_FILENAME", fname);
        xhr.setRequestHeader("X-FILENAME", fname);
        
        var nonce_data = jQuery('input[name="arf_editor_nonce"]').val();

        var formData = new FormData();
        formData.append('action', 'arf_add_new_preset');  
        formData.append('preset_file', file);
        formData.append( '_nonce', nonce_data );
        xhr.send(formData);

        xhr.onreadystatechange = function(e) {
            if (xhr.readyState == 4) {
                if (xhr.status == 200) {
                    jQuery('.arf_preset_field_content_wrapper_' + field_key).find('button.btn_2').css('opacity', '');
                    var data = xhr.responseText;
                    if( /error/g.test(data) ){
                        var invalid_csv_msg = data.split('~|~');
                        jQuery('#error_message').find('.message_descripiton > div').first().html(invalid_csv_msg[1]);
                        error_msg();
                        jQuery('#arf_preset_data_'+field_key).val('');
                    } else {
                        jQuery('#arf_preset_data_' + field_key).attr('db_file_name', data);
                    }
                }
            }
        };
    }
    function UploadFile(file, field_key) {
        if (file.type.indexOf('image') < 0) {
            jQuery('[data-val="'+field_key+'"]').val('');
            jQuery("#error_message").find('.message_descripiton > div').first().html(__ARF_UPLOAD_IMG_MSG);
            error_msg();
            return false;
        }
        var is_radio_checkbox_image = false;
        var arf_chk_rdo_image_id;
        if (typeof(field_key) != 'undefined') {
            var arf_image_label_field = '';
            arf_image_label_field = field_key.split('_radio_label_image_');
            var image_url = jQuery('[data-id="arfmainformurl"]').val();
            var image_url_val = image_url + '/images/ajax-loader1.gif';
            if (arf_image_label_field[0] == 'arf_add_radio' && typeof(field_key) != 'undefined') {
                var pt_id = "arf_radio_label_image_" + arf_image_label_field[1];
                arf_chk_rdo_image_id = arf_image_label_field[1];
                jQuery('#' + pt_id).html('<img src=' + image_url_val + ' style="float: left; margin: 0 10px 0 0; height: 20px; width: 20px;" />');
                is_radio_checkbox_image = true;
            }
        }
        
        if (field_key == 'form_bg') {
            jQuery('#ajax_form_loader').show();
        } else if (field_key == 'submit_hover_bg') {
            jQuery('#ajax_submit_hover_loader').show();
        } else if( field_key == 'submit_btn_img' ){
            jQuery('#ajax_submit_loader').show();
        }
        if( /arf_img_control_image_control/.test(field_key) ){
            jQuery('.arf_imagecontrol_loader').css('display','inline-block');
        }
        if (location.host.indexOf("sitepointstatic") >= 0) return
        var xhr = new XMLHttpRequest();
        var seconds = new Date().getTime();
        var index = file.name.lastIndexOf('.'); 
        var extension = file.name.substring(index + 1); 
        var filename = /.*(?=\.)/.exec(file.name);
        var fname1 = seconds + "_" + filename;
        fname = fname1.replace(/[^\w\s]/gi, '').replace(/ /g, "") + '.' + extension;
        var arfmainformurl = jQuery('[data-id="arfmainformurl"]').val();
        var arffiledragurl = jQuery('[data-id="arffiledragurl"]').val();
        
        var ajax_url = document.getElementById('arfajaxurl').value;
        xhr.open("POST",ajax_url);

        var nonce_data = jQuery('input[name="arf_editor_nonce"]').val();
        
        var param_data = new FormData();
        param_data.append('action','arf_send_form_data_admin');
        param_data.append('files',file);
        param_data.append('_nonce', nonce_data );

        xhr.setRequestHeader("X_FILENAME", fname);
        xhr.setRequestHeader("X-FILENAME", fname);
        
        xhr.send(param_data);

        xhr.onreadystatechange = function(e) {
            if (xhr.readyState == 4) {
                if (xhr.status == 200) {
                    var data = xhr.responseText;
                    if( /(error_upload)/g.test(data) ){
                        var message = jQuery(data).text();
                        jQuery("#error_message").find('.message_descripiton > div').first().html(message);
                        if( true == is_radio_checkbox_image ){
                            jQuery('#arf_radio_label_image_'+arf_chk_rdo_image_id ).html('');
                            jQuery('#del_img_id_'+arf_chk_rdo_image_id).hide();
                        }
                        jQuery('.arf_imagecontrol_loader').hide();
                        error_msg();
                        jQuery('.arf_form_style_file_upload_loader').hide();
                        return false;
                    }
                    var arf_smiley_field = '';
                    var arf_radio_image_label_field = '';
                    var arf_imagecontrol_field = '';
                    if (typeof(field_key) != 'undefined') {
                        arf_smiley_field = field_key.split('_smiley_image_');
                        arf_radio_image_label_field = field_key.split('_radio_label_image_');
                        arf_imagecontrol_field = field_key.split('_image_control_');
                    }
                    if (field_key == 'form_bg' && field_key != 'undefined') {
                        document.getElementById('imagename_form').value = data;
                        if (!jQuery.isFunction(change_form_bg_img)) {
                            return;
                        }
                        change_form_bg_img();
                    } else if (field_key == 'submit_hover_bg' && field_key != 'undefined') {
                        document.getElementById('imagename_submit_hover').value = data;
                        if (!jQuery.isFunction(change_submit_hover_img)) {
                            return;
                        }
                        change_submit_hover_img();
                    } else if (arf_smiley_field[0] == 'arf_smiley_add' && field_key != 'undefined') {
                        var data1 = arf_smiley_field[1] + '_arf_smiley_' + data;
                        document.getElementById('arf_smiley_image_name').value = data1;
                        if( typeof change_smiley_image != 'undefined' ){
                            change_smiley_image();
                        }                        
                    } else if (arf_radio_image_label_field[0] == 'arf_add_radio' && typeof(field_key) != 'undefined') {
                        var data1 = arf_radio_image_label_field[1] + '_arf_radio_image_' + data;
                        document.getElementById('arf_radio_image_name').value = data1;
                        if (!jQuery.isFunction(change_radio_image)) {
                            return;
                        }
                        change_radio_image(arf_radio_image_label_field[1]);
                    } else if (arf_imagecontrol_field[0] == 'arf_img_control' && typeof(field_key != "undefined")) {
                        var data1 = arf_imagecontrol_field[1] + '_image_control_' + data;
                        var upload_url = document.getElementById('arfuploadurl').value;
                        var imageUrl = upload_url + data;
                        document.getElementById('arfimage_url_' + arf_imagecontrol_field[1]).value = imageUrl;
                        jQuery('.arf_imagecontrol_loader').css('display','none');
                    } else {
                        document.getElementById('imagename').value = data;
                        if (!jQuery.isFunction(change_submit_img)) {
                            return;
                        }
                        change_submit_img();
                    }
                }
            }
        };
    }

    function UploadEmailAttachmentFile(file, field_key) {

        if(field_key == 'user_email_attachment'){
            jQuery('#arf_ajax_email_attachment_loader').show();
        }

        if (location.host.indexOf("sitepointstatic") >= 0) return
        var xhr = new XMLHttpRequest();
        var seconds = new Date().getTime();
        var index = file.name.lastIndexOf('.'); 
        var extension = file.name.substring(index + 1); 
        var filename = /.*(?=\.)/.exec(file.name);
        var fname1 = seconds + "_" + filename;
        fname = fname1.replace(/[^\w\s]/gi, '').replace(/ /g, "") + '.' + extension;
        var arfmainformurl = jQuery('[data-id="arfmainformurl"]').val();
        var arffiledragurl = jQuery('[data-id="arffiledragurl"]').val();
        
        var ajax_url = document.getElementById('arfajaxurl').value;
        xhr.open("POST",ajax_url);

        var nonce_data = jQuery('input[name="arf_editor_nonce"]').val();
        
        var param_data = new FormData();
        param_data.append('action','arf_add_user_email_notification_attachment_admin');
        param_data.append('files',file);
        param_data.append('_nonce', nonce_data );

        xhr.setRequestHeader("X_FILENAME", fname);
        xhr.setRequestHeader("X-FILENAME", fname);
        
        xhr.send(param_data);

        xhr.onreadystatechange = function(e) {
            if (xhr.readyState == 4) {
                if (xhr.status == 200) {
                    var data = xhr.responseText;
                    if( /(error_upload)/g.test(data) ){
                        var message = jQuery(data).text();
                        jQuery("#error_message").find('.message_descripiton > div').first().html(message);
                        error_msg();
                        jQuery('.arf_email_attachment_file_upload_loader').hide();
                        return false;
                    }

                    if (field_key == 'user_email_attachment' && field_key != 'undefined') {
                        document.getElementById('user_email_attachment').value = data;
                        if (!jQuery.isFunction(change_user_email_notification_attachment)) {
                            return;
                        }
                        change_user_email_notification_attachment(fname,file.name);
                    }
                }
            }
        };
    }


    function Init() {
        var fileselect = $id("field_w4ge3s");
        fileselect.addEventListener("change", FileSelectHandler, false);
        var xhr = new XMLHttpRequest();
        if (xhr.upload) {}
    }
    if (window.File && window.FileList && window.FileReader) {
    }
    jQuery(document).on('click', '.original', function() {
        var fileselect = $id(jQuery(this).attr('id'));
        fileselect.addEventListener("change", FileSelectHandler2, false);
        var xhr = new XMLHttpRequest();
        if (xhr.upload) {}
    });
    jQuery(document).on('click', '.arf_preset_data', function() {
        var fileselect = $id(jQuery(this).attr('id'));
        fileselect.addEventListener("change", FilePresetFieldHandler, false);
        var xhr = new XMLHttpRequest();
        if (xhr.upload) {}
    });
    jQuery(document).on('click', '.arf_email_attachment', function() {
        var fileselect = $id(jQuery(this).attr('id'));
        fileselect.addEventListener("change", FileEmailAttachmentHandler, false);
        var xhr = new XMLHttpRequest();
        if (xhr.upload) {}
    });
    jQuery('.iframe_original_btn').click(function(e) {
        var fieldmainname_list = jQuery('[data-id="arfmainform_bg_img"]').val();
        if (fieldmainname_list != '') {
            return false;
        }
        var field_key = jQuery(this).attr('data-id').replace('div_', '');
        jQuery('#' + field_key + '_iframe').contents().find("#fileselect").click();
        var field_name = jQuery(this).attr('data-id');
        jQuery('#arf_field_' + field_name + '_container').find('.help-block').empty();
        jQuery('#progress_' + field_key).hide();
        var result = jQuery('#' + field_key + '_iframe').contents().find("#fileselect").val();
        if (result !== undefined && result != '') {
            var field_type = jQuery('#file_types_' + field_key).val();
            types_arr = field_type.split(",");
            var field_name = jQuery(this).attr('data-id');
            var file_name = result.replace(/C:\\fakepath\\/i, '');
            var frmid = jQuery(this).attr('data-form-id');
            var seconds = new Date().getTime();
            var index = file_name.lastIndexOf('.'); 
            var extension = file_name.substring(index + 1); 
            var filename = /.*(?=\.)/.exec(file_name);
            var fname1 = seconds + "_" + filename;
            var fname = fname1.replace(/[^\w\s]/gi, '').replace(' ', '') + '.' + extension;
            var field_id = field_key;
            var is_preview = 0;
            var arfmainformurl = jQuery('[data-id="arfmainformurl"]').val();
            var arffiledragurl = jQuery('[data-id="arffiledragurl"]').val();
            var file_type = '';
            var ie_version = 9;
            var arf_ajax_url = jQuery('.arf_ajax_url').val();
            var browser = "Internet Explorer";
            if (field_key == 'arfmfbi') {
                jQuery('#ajax_form_loader').show();
            } else jQuery('#ajax_submit_loader').show();
            
            jQuery("#" + field_key + '_iframe').contents().find('form').attr('action',arf_ajax_url+'?action=arf_send_form_data_admin&frm='+frm_id+'&field_id='+field_id+'&fname='+fname+'&file_type='+file_type+'&types_arr='+types_arr+'&is_preview='+is_preview+'&ie_version='+ie_version+'&browser='+browser);

            jQuery('#' + field_key + '_iframe').contents().find('form').submit();
            jQuery('#div_' + field_key).css('margin-top', "-4px");
            jQuery('#info_' + field_key).css('display', 'inline-block');
            jQuery('#info_' + field_key + ' #file_name').html(result.replace(/C:\\fakepath\\/i, ''));
            jQuery('#info_' + field_key + ' .percent').html('').show();
            jQuery('#info_' + field_key + ' #percent').html('Uploading...');
            jQuery('#progress_' + field_key + ' div.bar').animate({
                width: "100%"
            }, 'slow');
            var myInterval = setInterval(function() {
                if (jQuery('#' + field_key + '_iframe').contents()) {
                    jQuery('#' + field_key + '_iframe').load(function() {
                        var uploaded = (jQuery('#' + field_key + '_iframe').contents()) ? jQuery('#' + field_key + '_iframe').contents().find('.uploaded').length : 0;
                        if (uploaded > 0) {
                            clearInterval(myInterval);
                            jQuery('#progress_' + field_key).removeClass('active');
                            jQuery('#imagename_form').val(fname);
                            jQuery('#form_bg_img_div').css('background', 'none');
                            jQuery('#form_bg_img_div').css('border', '0px');
                            jQuery('#form_bg_img_div').css('padding', '0px');
                            jQuery('#form_bg_img_div').css('box-shadow', 'none');
                            if (!jQuery.isFunction(change_form_bg_img)) {
                                return;
                            }
                            change_form_bg_img();
                            jQuery('#div_' + field_key).hide();
                            jQuery('#remove_' + field_key).css('display', 'block');
                            jQuery('#div_' + field_key).css('margin-top', "0px");
                            jQuery('#remove_' + field_key).css('margin-top', "-4px");
                            jQuery('#' + field_key + '_iframe_div').html(' ').append('<iframe id="' + field_key + '_iframe" src="' + arffiledragurl + '/core/views/iframe.php"></iframe>');
                        }
                        var error_upload = (jQuery('#' + field_key + '_iframe').contents()) ? jQuery('#' + field_key + '_iframe').contents().find('.error_upload').length : 0;
                        if (error_upload > 0) {
                            clearInterval(myInterval);
                            var field_id = field_name;
                            jQuery('input[name="file' + field_id + '"]').attr('data-file-valid', 'false'); 						
                            
                            if (typeof(__ARFERR) != 'undefined') var file_error = __ARFERR;
                            else var file_error = 'Sorry, this file type is not permitted for security reasons.';
                            if (jQuery('#field_' + field_key).attr('data-invalid-message') !== undefined && jQuery('#field_' + field_key).attr('data-invalid-message') != '') var arf_invalid_file_message = jQuery('#field_' + field_key).attr('data-invalid-message');
                            else var arf_invalid_file_message = file_error;
                            jQuery('#arf_field_' + field_id + '_container').removeClass('success');
                            var $this = jQuery('#arf_field_' + field_id + '_container .controls');
                            var $controlGroup = $this.parents(".control-group").first();
                            var $helpBlock = $controlGroup.find(".help-block").first();
                            var form_id = $this.closest('form').find('[data-id="form_id"]').val();
                            var error_type = (jQuery('[data-id="form_tooltip_error_' + form_id + '"]').val() == 'advance') ? 'advance' : 'normal';
                            if (error_type == 'advance') {
                                if (!jQuery.isFunction(arf_show_tooltip)) {
                                    return;
                                }
                                arf_show_tooltip($controlGroup, $helpBlock, arf_invalid_file_message);
                            } else {
                                if (!$helpBlock.length) {
                                    $helpBlock = jQuery('<div class="help-block"><ul><li>' + arf_invalid_file_message + '</li></ul></div>');
                                    $controlGroup.find('.controls').append($helpBlock);
                                } else {
                                    $helpBlock = jQuery('<ul><li>' + arf_invalid_file_message + '</li></ul>');
                                    $controlGroup.find('.controls .help-block').append($helpBlock);
                                }
                            }
                            jQuery('#' + field_key + '_iframe_div').html(' ').append('<iframe id="' + field_key + '_iframe" src="' + arffiledragurl + '/core/views/iframe.php"></iframe>');
                        }
                    });
                }
            }, 100);
        }
    });
    jQuery('.iframe_submit_original_btn').click(function(e) {
        var fieldmainname_list = jQuery('#arfsubmitbuttonimagesetting').val();
        if (fieldmainname_list != '') {
            return false;
        }
        var field_key = jQuery(this).attr('data-id').replace('div_', '');
        jQuery('#' + field_key + '_iframe').contents().find("#fileselect").click();
        var field_name = jQuery(this).attr('data-id');
        jQuery('#arf_field_' + field_name + '_container').find('.help-block').empty();
        var result = jQuery('#' + field_key + '_iframe').contents().find("#fileselect").val();
        if (result != '' && result !== undefined) {
            var field_type = jQuery('#file_types_' + field_key).val();
            types_arr = field_type.split(",");
            var field_name = jQuery(this).attr('data-id');
            var file_name = result.replace(/C:\\fakepath\\/i, '');
            var frmid = jQuery(this).attr('data-form-id');
            var seconds = new Date().getTime();
            var index = file_name.lastIndexOf('.'); 
            var extension = file_name.substring(index + 1); 
            var filename = /.*(?=\.)/.exec(file_name);
            var fname1 = seconds + "_" + filename;
            var fname = fname1.replace(/[^\w\s]/gi, '').replace(' ', '') + '.' + extension;
            var field_id = field_key;
            var is_preview = 0;
            var arfmainformurl = jQuery('[data-id="arfmainformurl"]').val();
            var arffiledragurl = jQuery("[data-id='arffiledragurl']").val();
            var file_type = '';
            var ie_version = 9;
            var arf_ajax_url = jQuery('.arf_ajax_url').val();
            var browser = "Internet Explorer";
            
            jQuery("#" + field_key + '_iframe').contents().find('form').attr('action',arf_ajax_url+'?action=arf_send_form_data_admin&frm='+frm_id+'&field_id='+field_id+'&fname='+fname+'&file_type='+file_type+'&types_arr='+types_arr+'&is_preview='+is_preview+'&ie_version='+ie_version+'&browser='+browser);

            jQuery('#' + field_key + '_iframe').contents().find('form').submit();
            jQuery('#div_' + field_key).css('margin-top', "-4px");
            
            jQuery('#info_' + field_key).css('display', 'inline-block');
            jQuery('#info_' + field_key + ' #file_name').html(result.replace(/C:\\fakepath\\/i, ''));
            jQuery('#info_' + field_key + ' .percent').html('').show();
            jQuery('#info_' + field_key + ' #percent').html('Uploading...');
            jQuery('#progress_' + field_key + ' div.bar').animate({
                width: "100%"
            }, 'slow');
            var myInterval = setInterval(function() {
                if (jQuery('#' + field_key + '_iframe').contents()) {
                    jQuery('#' + field_key + '_iframe').load(function() {
                        var uploaded = jQuery('#' + field_key + '_iframe').contents().find('.uploaded').length;
                        if (uploaded > 0) {
                            clearInterval(myInterval);
                            jQuery('#progress_' + field_key).removeClass('active');
                            jQuery('#imagename').val(fname);
                            jQuery('#submit_btn_img_div').css('background', 'none');
                            jQuery('#submit_btn_img_div').css('border', '0px');
                            jQuery('#submit_btn_img_div').css('padding', '0px');
                            jQuery('#submit_btn_img_div').css('box-shadow', 'none');
                            if (!jQuery.isFunction(change_submit_img)) {
                                return;
                            }
                            change_submit_img();
                            jQuery('#div_' + field_key).hide();
                            jQuery('#remove_' + field_key).css('display', 'block');
                            jQuery('#div_' + field_key).css('margin-top', "0px");
                            jQuery('#remove_' + field_key).css('margin-top', "-4px");
                            jQuery('#info_' + field_key + ' #percent').html('File Uploaded');
                            jQuery('input[name="file' + field_name + '"]').val(filename);
                            jQuery('input[name="item_meta[' + field_name + ']"]').val(filename);
                            jQuery('input[name="file' + field_name + '"]').attr('data-file-valid', 'true'); 
                            jQuery('#' + field_key + '_iframe_div').html(' ').append('<iframe id="' + field_key + '_iframe" src="' + arffiledragurl + '/core/views/iframe.php"></iframe>');
                        }
                        var error_upload = jQuery('#' + field_key + '_iframe').contents().find('.error_upload').length;
                        if (error_upload > 0) {
                            clearInterval(myInterval);
                            var field_id = field_name;
                            jQuery('input[name="file' + field_id + '"]').attr('data-file-valid', 'false'); 							
                            if (typeof(__ARFERR) != 'undefined') var file_error = __ARFERR;
                            else var file_error = 'Sorry, this file type is not permitted for security reasons.';
                            if (jQuery('#field_' + field_key).attr('data-invalid-message') !== undefined && jQuery('#field_' + field_key).attr('data-invalid-message') != '') var arf_invalid_file_message = jQuery('#field_' + field_key).attr('data-invalid-message');
                            else var arf_invalid_file_message = file_error;
                            jQuery('#arf_field_' + field_id + '_container').removeClass('success');
                            var $this = jQuery('#arf_field_' + field_id + '_container .controls');
                            var $controlGroup = $this.parents(".control-group").first();
                            var $helpBlock = $controlGroup.find(".help-block").first();
                            var form_id = $this.closest('form').find('[data-id="form_id"]').val();
                            var error_type = (jQuery('[data-id="form_tooltip_error_' + form_id + '"]').val() == 'advance') ? 'advance' : 'normal';
                            if (error_type == 'advance') {
                                if (!jQuery.isFunction(arf_show_tooltip)) {
                                    return;
                                }
                                arf_show_tooltip($controlGroup, $helpBlock, arf_invalid_file_message);
                            } else {
                                if (!$helpBlock.length) {
                                    $helpBlock = jQuery('<div class="help-block"><ul><li>' + arf_invalid_file_message + '</li></ul></div>');
                                    $controlGroup.find('.controls').append($helpBlock);
                                } else {
                                    $helpBlock = jQuery('<ul><li>' + arf_invalid_file_message + '</li></ul>');
                                    $controlGroup.find('.controls .help-block').append($helpBlock);
                                }
                            }
                            jQuery('#' + field_key + '_iframe_div').html(' ').append('<iframe id="' + field_key + '_iframe" src="' + arffiledragurl + '/core/views/iframe.php"></iframe>');
                        }
                    });
                }
            }, 100);
        }
    });
    jQuery('.iframe_submit_hover_original_btn').click(function(e) {
        var fieldmainname_list = jQuery('#arfsubmithoverbuttonimagesetting').val();
        if (fieldmainname_list != '') {
            return false;
        }
        var field_key = jQuery(this).attr('data-id').replace('div_', '');
        jQuery('#' + field_key + '_iframe').contents().find("#fileselect").click();
        var field_name = jQuery(this).attr('data-id');
        jQuery('#arf_field_' + field_name + '_container').find('.help-block').empty();
        var result = jQuery('#' + field_key + '_iframe').contents().find("#fileselect").val();
        if (result != '' && result !== undefined) {
            var field_type = jQuery('#file_types_' + field_key).val();
            types_arr = field_type.split(",");
            var field_name = jQuery(this).attr('data-id');
            var file_name = result.replace(/C:\\fakepath\\/i, '');
            var frmid = jQuery(this).attr('data-form-id');
            var seconds = new Date().getTime();
            var index = file_name.lastIndexOf('.'); 
            var extension = file_name.substring(index + 1); 
            var filename = /.*(?=\.)/.exec(file_name);
            var fname1 = seconds + "_" + filename;
            var fname = fname1.replace(/[^\w\s]/gi, '').replace(' ', '') + '.' + extension;
            var field_id = field_key;
            var is_preview = 0;
            var arfmainformurl = jQuery('[data-id="arfmainformurl"]').val();
            var arffiledragurl = jQuery("[data-id='arffiledragurl']").val();
            var file_type = '';
            var ie_version = 9;
            var browser = "Internet Explorer";
            var arf_ajax_url = jQuery('.arf_ajax_url').val();
            
            jQuery("#" + field_key + '_iframe').contents().find('form').attr('action',arf_ajax_url+'?action=arf_send_form_data_admin&frm='+frm_id+'&field_id='+field_id+'&fname='+fname+'&file_type='+file_type+'&types_arr='+types_arr+'&is_preview='+is_preview+'&ie_version='+ie_version+'&browser='+browser);

            jQuery('#' + field_key + '_iframe').contents().find('form').submit();
            jQuery('#div_' + field_key).css('margin-top', "-4px");
            
            jQuery('#info_' + field_key).css('display', 'inline-block');
            jQuery('#info_' + field_key + ' #file_name').html(result.replace(/C:\\fakepath\\/i, ''));
            jQuery('#info_' + field_key + ' .percent').html('').show();
            jQuery('#info_' + field_key + ' #percent').html('Uploading...');
            jQuery('#progress_' + field_key + ' div.bar').animate({
                width: "100%"
            }, 'slow');
            var myInterval = setInterval(function() {
                if (jQuery('#' + field_key + '_iframe').contents()) {
                    jQuery('#' + field_key + '_iframe').load(function() {
                        var uploaded = jQuery('#' + field_key + '_iframe').contents().find('.uploaded').length;
                        if (uploaded > 0) {
                            clearInterval(myInterval);
                            jQuery('#progress_' + field_key).removeClass('active');
                            jQuery('#imagename').val(fname);
                            jQuery('#submit_hover_btn_img_div').css('background', 'none');
                            jQuery('#submit_hover_btn_img_div').css('border', '0px');
                            jQuery('#submit_hover_btn_img_div').css('padding', '0px');
                            jQuery('#submit_hover_btn_img_div').css('box-shadow', 'none');
                            if (!jQuery.isFunction(change_submit_hover_img)) {
                                return;
                            }
                            change_submit_hover_img();
                            jQuery('#div_' + field_key).hide();
                            jQuery('#remove_' + field_key).css('display', 'block');
                            jQuery('#div_' + field_key).css('margin-top', "0px");
                            jQuery('#remove_' + field_key).css('margin-top', "-4px");
                            jQuery('#info_' + field_key + ' #percent').html('File Uploaded');
                            jQuery('input[name="file' + field_name + '"]').val(filename);
                            jQuery('input[name="item_meta[' + field_name + ']"]').val(filename);
                            jQuery('input[name="file' + field_name + '"]').attr('data-file-valid', 'true'); 
                            jQuery('#' + field_key + '_iframe_div').html(' ').append('<iframe id="' + field_key + '_iframe" src="' + arffiledragurl + '/core/views/iframe.php"></iframe>');
                        }
                        var error_upload = jQuery('#' + field_key + '_iframe').contents().find('.error_upload').length;
                        if (error_upload > 0) {
                            clearInterval(myInterval);
                            var field_id = field_name;
                            jQuery('input[name="file' + field_id + '"]').attr('data-file-valid', 'false'); 						
                            if (typeof(__ARFERR) != 'undefined') var file_error = __ARFERR;
                            else var file_error = 'Sorry, this file type is not permitted for security reasons.';
                            if (jQuery('#field_' + field_key).attr('data-invalid-message') !== undefined && jQuery('#field_' + field_key).attr('data-invalid-message') != '') var arf_invalid_file_message = jQuery('#field_' + field_key).attr('data-invalid-message');
                            else var arf_invalid_file_message = file_error;
                            jQuery('#arf_field_' + field_id + '_container').removeClass('success');
                            var $this = jQuery('#arf_field_' + field_id + '_container .controls');
                            var $controlGroup = $this.parents(".control-group").first();
                            var $helpBlock = $controlGroup.find(".help-block").first();
                            var form_id = $this.closest('form').find('[data-id="form_id"]').val();
                            var error_type = (jQuery('[data-id="form_tooltip_error_' + form_id + '"]').val() == 'advance') ? 'advance' : 'normal';
                            if (error_type == 'advance') {
                                if (!jQuery.isFunction(arf_show_tooltip)) {
                                    return;
                                }
                                arf_show_tooltip($controlGroup, $helpBlock, arf_invalid_file_message);
                            } else {
                                if (!$helpBlock.length) {
                                    $helpBlock = jQuery('<div class="help-block"><ul><li>' + arf_invalid_file_message + '</li></ul></div>');
                                    $controlGroup.find('.controls').append($helpBlock);
                                } else {
                                    $helpBlock = jQuery('<ul><li>' + arf_invalid_file_message + '</li></ul>');
                                    $controlGroup.find('.controls .help-block').append($helpBlock);
                                }
                            }
                            jQuery('#' + field_key + '_iframe_div').html(' ').append('<iframe id="' + field_key + '_iframe" src="' + arffiledragurl + '/core/views/iframe.php"></iframe>');
                        }
                    });
                }
            }, 100);
        }
    });
})();